#################3
#
# logrep - downloads logfiles and generates html reports daily from target machines
# Command line parameters:
#
#	-m <mode> - 1 - daily, 2 - snapshot
#	
# v1.0 - initial version, jun 2002, Tevfik K. (tevfik@itefix.no)
#

use Getopt::Std;

# Get command line parameter 
getopts("m:") or die $!;
$mode = $opt_m;

do "parameters.pl";

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday) = gmtime();

$year += 1900; 		#4-digit year
$mon++; 			# make relative to 1

# Logfile logrep operations
$logfile = sprintf "$logdir\\logrep\\%02d%02d.log", $mon, $mday;

$i = 0;

foreach (@nodes) {

	$system = $nodes [$i][0];
	$node = $nodes [$i][1];
	$i++;

	# Generate pathinfo	
	$logpath = "$rootpath\\log\\$system\\$node\\" . (($mode == 1) ? $year : "snapshot");
	$localpath = sprintf ("$logpath\\%02d%02d", $mon, $mday);
	$filename = $system .(($mode == 1) ? ".full" : ".snapshot");
	$remotepath = "$login\@$node:$filename";
	
	#DEBUG! print "$remotepath, $localpath\n";
	system "echo *l*o*g*r*e*p* - mode $mode (1-daily, 2-hourly) >> $logfile";
	system "echo Download logfile from $remotepath to $localpath >> $logfile";

	# download logfile
	system "scp.exe -q -i $keyfile $remotepath $localpath >> $logfile";
	
	system "ls -l $localpath >> $logfile";

	next if !(-e $localpath); # Local logfile doesn't exist. Go to next!
	
	# web directory for html reports
	$webdirnode = $webdir . "\\$system\\$node\\" . (($mode == 1) ? "daily" : "snapshot");
	
	system "echo Generate html reports in $webdirnode >> $logfile";
	# Generate html reports
	system "$progdir\\module-$system.pl -l $localpath -w $webdirnode >> $logfile";
	system "echo ++++++++++ >> $logfile";

}






