#########
#
# "W3C HTTPD Common Log File Format" module for log reporting system
# v1.0 - Initial version, Sep 2002, Tevfik K. (tevfik@itefix.no)

# Sets analysis parameters - specific for each module

@dim = ( "from", "user", "authuser", "day", "month", "hour", "method", "document", "result", "kbsize");

# Get common functions & parameters
do "lib1.pl";

################
# MAIN PROGRAM #
################

SetCommonParameters ();

# initialize counters
$n = 0;

ProcessClfLogFile ($logfilename);

WriteIndexPage (
	"Common Logfile analysis",
	"Log Analysis Table"
	);

WriteDetailsPages ();

###############
# SUBROUTINES #
###############

# ProcessClfLogFile : 
#	Processes logfile in CLF format and populates counter arrays
#	Parameter : filename
#
sub ProcessClfLogFile {

	my $logfile = shift;
	
	open LOGFILE, $logfile or die $dieopenmsg;

LOOP: 
	while (<LOGFILE>) {

		my $line = $_;

		($from, $user, $authuser, $day, $monthmmm, $hour, $minute, $request, $result, $size) = 
			($line =~ m!(\S+) (\S+) (\S+) \[(\d\d)\/(\w\w\w)\/\d\d\d\d:(\d\d):(\d\d).+"(.+)" (\d+) (\S+)!) ;

		# parse request field
		($method, $document) = ($request ne "-") ? split (/ /, $request) : ("-", "-");
		
		# Some normalization
		($document) = split (/\?/, $document); # document w/o parameters
		$kbsize = int ($size / 1024); # Size in KB
		$month = $monthnr {$monthmmm}; # Month number
		
		($startdate = "$month/$day $hour:$minute") if ($. == 1);
				
		print "$. " if  ((($./5000) - int($./5000) ) == 0) ;
		
		#DEBUG! print "$from, $user, $authuser, $day, $month, $hour, $minute, $method, $document, $result, $kbsize\n";
		
		GenerateTables ();
	}
	
	$enddate = "$month/$day $hour:$minute";

	$n = $.;
	
	close LOGFILE or die $dieclosemsg;
}
