#########
#
# "Microsoft IIS-W3C Extended Logfile Format (default) module for log reporting system
# v1.0 - Initial version, Sep 2002, Tevfik K. (tevfik@itefix.no)

# Sets analysis parameters - specific for each module

@dim = ( "month", "day", "hour", "from", "user", "to", "port", "method", "document", "result");

# Get common functions & parameters
do "lib1.pl";

################
# MAIN PROGRAM #
################

SetCommonParameters ();

# initialize counters
$n = $nstart = 0;

ProcessIisLogFile ($logfilename);

WriteIndexPage (
	"IIS Logfile analysis",
	"Log Analysis Table",
	"Number of (re)starts : ", $nstart / 4
	);

WriteDetailsPages ();

###############
# SUBROUTINES #
###############

# ProcessIisLogFile : 
#	Processes IIS logfile and populates counter arrays
#	Parameter : log filename
#
sub ProcessIisLogFile {

	my $logfile = shift;
	
	my $nl = 0;
		
	open LOGFILE, $logfile or die $dieopenmsg;

LOOP: 
	while (<LOGFILE>) {

		my $line = $_;
		
		if (/^#/) {
			$nstart++;
			next LOOP;
		}
		
		$nl++;
		
		($month, $day, $hour, $minute, $from, $user, $to, $port, $method, $document, $result)= 
			($line =~ m"\d\d\d\d-(\d\d)-(\d\d) (\d\d):(\d\d)\S+ (\S+) (\S+) (\S+) (\d+) (\w+) (\S+) \S+ (\d+)") ;
				
		($startdate = "$month/$day $hour:$minute") if ($nl == 1);
				
		print "$. " if  ((($./1000) - int($./1000) ) == 0) ;
		
		#DEBUG! print "$month, $day, $hour, $minute, $from, $user, $to, $port, $method, $document, $result\n";
		
		GenerateTables ();
	}
	
	$enddate = "$month/$day $hour:$minute";

	$n = $.;
	
	close LOGFILE or die $dieclosemsg;
}
